![Polmyer Element](https://raw.githubusercontent.com/bwu-dart/bwu_datagrid/master/doc/screenshots/polymer_logo.png)

# Welcome to BWU Datagrid

[![Star this Repo](https://img.shields.io/github/stars/bwu-dart/bwu_datagrid.svg?style=flat)](https://github.com/bwu-dart/bwu_datagrid)
[![Pub Package](https://img.shields.io/pub/v/bwu_datagrid.svg?style=flat)](https://pub.dartlang.org/packages/bwu_datagrid)
[![Build Status](https://travis-ci.org/bwu-dart/bwu_datagrid.svg?branch=master)](https://travis-ci.org/bwu-dart/bwu_datagrid)
[![Coverage Status](https://coveralls.io/repos/bwu-dart/bwu_datagrid/badge.svg?branch=master)](https://coveralls.io/r/bwu-dart/bwu_datagrid)

## BWU Datagrid is an advanced Polymer.dart grid/spreadsheet component
BWU Datagrid is a Dart port from [SlickGrid](https://github.com/mleibman/SlickGrid)

Find **examples** in [the wiki](https://github.com/bwu-dart/bwu_datagrid/wiki).  
The source code for the examples was moved to https://github.com/bwu-dart/bwu_datagrid_examples

**UPDATE:  Nov 25th, 2015**

### Status

#### Polymer compatibility: 
- Polymer >= 1.0.0: BWU Datagrid versions >= 0.1.0  
- Polymer <= 0.16.4 BWU Datagrid versions <= 0.0.30

#### Most things are already working:

* Basic rendering
* Scrolling and manual column resize
* Editing, Custom Editors, Custom Validators
* The examples work also when built to JavaScript
* Full keyboard navigation
* Column resize/reorder/show/hide
* Column autosizing & force-fit
* Pluggable cell formatters & editors
* Support for editing and creating new rows.
* Advanced detached & multi-field editors with undo/redo support.
* Background post-rendering for richer cells
* Configurable & customizable
* Grouping, filtering, custom aggregators, and more!
* “GlobalEditorLock” to manage concurrent edits in cases where multiple Views on a page can edit the same data.

**Works best in Chrome** 
Better support for other browsers is work-in-progress.

### Some highlights (when it's ready):

(This description is copied from SlickGrid. The Dart port is not there yet)

* Adaptive virtual scrolling (handle hundreds of thousands of rows with extreme responsiveness)
* Extremely fast rendering speed
* ~~Supports jQuery UI Themes~~ (not sure yet)
* Support for [millions of rows](http://stackoverflow.com/a/2569488/1269037)

## Screenshots

### Composite Editor
![composite_editor_item_details](https://raw.githubusercontent.com/bwu-dart/bwu_datagrid/master/doc/screenshots/composite_editor_item_details.png)

### Custom Editors
![e03_editing_01](https://raw.githubusercontent.com/bwu-dart/bwu_datagrid/master/doc/screenshots/e03_editing_01.png)

### Inline Filter, Paging, ...
![e04_model](https://raw.githubusercontent.com/bwu-dart/bwu_datagrid/master/doc/screenshots/e04_model.png)

### Tree functionality
![e05_collapsing](https://raw.githubusercontent.com/bwu-dart/bwu_datagrid/master/doc/screenshots/e05_collapsing.png)

### Alternative Display
![e08_alternative_display](https://raw.githubusercontent.com/bwu-dart/bwu_datagrid/master/doc/screenshots/e08_alternative_display.png)

### Async Post Render
![e10_async_post_render](https://raw.githubusercontent.com/bwu-dart/bwu_datagrid/master/doc/screenshots/e10_async_post_render.png)

### Header row
![header_row](https://raw.githubusercontent.com/bwu-dart/bwu_datagrid/master/doc/screenshots/header_row.png)

### Checkbox row select
![checkbox_row_select](https://raw.githubusercontent.com/bwu-dart/bwu_datagrid/master/doc/screenshots/checkbox_row_select.png)

### Sort by column ascending/descending
![sort_ascending](https://raw.githubusercontent.com/bwu-dart/bwu_datagrid/master/doc/screenshots/sort_asc.png)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;![sort_descending](https://raw.githubusercontent.com/bwu-dart/bwu_datagrid/master/doc/screenshots/sort_desc.png)
